! ======================================================================
! Vectores de progresiones geometricas con razones proximas a 1
! x(i)=rx**i, y(i)=ry**i, p=<x,y>, r=rx*ry, p=r*(1-r**n)/(1-r)
! ======================================================================

PROGRAM blas1_2
IMPLICIT NONE

INTEGER, PARAMETER:: nmax=10000, nsal=11
REAL(KIND(0.d0)):: x(nmax), y(nmax)
REAL(KIND(0.d0)), PARAMETER:: rx = 0.999d0, ry = 0.9995d0
REAL(KIND(0.d0)):: pexacto, pef90, peblas, razon, errf90, errblas
REAL(KIND(0.d0)), EXTERNAL:: ddot
INTEGER n, incx, incy, i

OPEN (nsal,FILE='BLAS1-2.sal')

! Producto escalar conocido

DO i = 1, nmax
  x(i) = rx**i ; y(i) = ry**i
ENDDO
incx = 1 ; incy = 1

DO i = 1, 100
  n = nmax/i
  razon = rx * ry
  pexacto = razon * (1.d0-razon**n) / (1.d0-razon)
  pef90 = DOT_PRODUCT(x(1:n),y(1:n))
  peblas = ddot(n, x, incx, y, incy) 
  errf90 = 1.d2 * ABS((pef90-pexacto)/pexacto)
  errblas = 1.d2 * ABS((peblas-pexacto)/pexacto)    
  WRITE (nsal,'(/A,I7/A,T10,G25.17)') 'n = ', n, 'pexacto = ', pexacto
  WRITE (nsal,'(A,T10,G25.17,3X,A,G15.5)')                              &
        'pef90  = ', pef90,  '%err = ', errf90,                         &
        'peblas = ', peblas, '%err = ', errblas
ENDDO

ENDPROGRAM blas1_2