! ======================================================================
! Minimos cuadrados lineales. Nube en Rn
! ======================================================================

PROGRAM mincua_n_lapack
IMPLICIT NONE

INTEGER, PARAMETER:: m=12, n=4, lw=1000, ndat=11, nsal=12
REAL(KIND(0.d0)):: a(m,n), aa(m,n), b(m,1), w(lw), y(m), yy(m), res(m)
INTEGER i, info
CHARACTER trans

! Primera sentencia ejecutable
! ----------------------------

OPEN (nsal,FILE='MINCUA-n-lapack.sal')

! Datos del problema

OPEN (ndat,FILE='escalera.dat')
WRITE (nsal,'(A)') 'Nube de puntos: '

a(1:m,1) = 1.d0
DO i = 1, m
  READ (ndat,'(3F5.0,3X,G20.12)') a(i,2:4), b(i,1)
ENDDO
aa = a
y = b(1:m,1)

! DGELS. Solucion de minimos cuadrados de Ax=b

trans = 'N'
CALL dgels (trans, m, n, 1, a, m, b, m, w, lw, info)

! Resultados

yy(1:m) = MATMUL(aa,b(1:n,1))
res (1:m) = y - yy
WRITE (nsal,'(/A/27("="))') 'Calculos con DGELS (LAPACK)'
WRITE (nsal,'(/A2,3A6,3A)') ' i', '    f ', '    g ', '    c ',         &
   '         y      ', '         yy     ', '       res      '  
DO i = 1, m
  WRITE (nsal,'(I2,3F6.0,3F16.11)') i, aa(i,2:n), y(i), yy(i), res(i) 
ENDDO

WRITE (nsal,'(/A/9("-")/A,I2/A,(T15,A,I1,A,F20.16))') 'DGELS', 'info =',&
       info, 'Estimadores: ', ('x', i,'=', b(i,1), i=1,n)

WRITE (nsal,'(/A,F20.16)') 'Suma de cuadrados de residuales = ',        &
      DOT_PRODUCT (res,res)

WRITE (nsal,'(/A,F20.16)') 'Segun dgels = ', DOT_PRODUCT(b(n+1:m,1),b(n+1:m,1))

ENDPROGRAM mincua_n_lapack